#include "hmg.ch"
#include "hfcl.ch"
#include "hmg_BoxLetterShow.ch"
#include "hmg_printex.prg"

 Function Main()

*----------------------------------------*
* (c) Mustafa Lpez  mustalopez@gmail.com
*----------------------------------------*

  REQUEST DBFCDX , DBFFPT , DBFDBT
  RDDSETDEFAULT( "DBFCDX" )

  SET CODEPAGE TO SPANISH 
  SET LANGUAGE TO SPANISH 

  REQUEST HB_LANG_ES 
*----------------------------------*

  SET CENTURY ON
  SET DATE FRENCH
  SET ESCAPE ON
  SET NAVIGATION EXTENDED
  SET DELETED ON
  SET DATE FORMAT TO 'dd/mm/yyyy'
  SET BROWSESYNC ON
  SET INTERACTIVECLOSE ON
 
  PUBLIC BusNom , BusNomX ,  primpalix , Primpaliz , numix , bultox

*-----------------------------------------------------------------*
 SET TOOLTIPSTYLE BALLOON
// this follow rows is required ONLY for HMG Minigui compatibility
#ifdef __MINGW32__
   SET TOOLTIPBACKCOLOR { 193, 224, 255 } 
   SET TOOLTIPFORECOLOR { 000, 000, 000 }
#endi
*-----------------------------------------------------------------*
  
 PRIVATE aItems := {}
 PRIVATE aItemX := {}
 PRIVATE aItemZ := {}
 
 PRIVATE aTypeItems :={"CODABAR"}
 PRIVATE aValues :={""}

 PRIVATE aBarColor  := { 000, 000, 000 }
 PRIVATE aBackColor := { 255, 255, 255 }

 PRIVATE criptOXz , AlItemX , AlItemX2 , mirax, nLogX , nLogz , xnLogX , xnLogQ
 
*-----------------------------------------*

        aadd ( aItems , '01 lava        ' )
        aadd ( aItems , '02 Albacete     ' )
        aadd ( aItems , '03 Alicante     ' )
        aadd ( aItems , '04 Almera      ' )
        aadd ( aItems , '05 vila        ' )
        aadd ( aItems , '06 Badajoz      ' )
        aadd ( aItems , '07 P.Mallorca   ' )
        aadd ( aItems , '08 Barcelona    ' )
        aadd ( aItems , '09 Burgos       ' )
        aadd ( aItems , '10 Cceres      ' )
        aadd ( aItems , '11 Cdiz        ' )
        aadd ( aItems , '12 Castelln    ' )
        aadd ( aItems , '13 Ciudad Real  ' )
        aadd ( aItems , '14 Crdoba      ' )
        aadd ( aItems , '15 Corua       ' )
        aadd ( aItems , '16 Cuenca       ' )
        aadd ( aItems , '17 Girona       ' )
        aadd ( aItems , '18 Granada      ' )
        aadd ( aItems , '19 Guadalajara  ' )
        aadd ( aItems , '20 San Sebastian' )  
        aadd ( aItems , '21 Huelva       ' )
        aadd ( aItems , '22 Huesca       ' )
        aadd ( aItems , '23 Jan         ' )
        aadd ( aItems , '24 Len         ' )
        aadd ( aItems , '25 Lleida       ' )
        aadd ( aItems , '26 Logroo      ' )
        aadd ( aItems , '27 Lugo         ' )
        aadd ( aItems , '28 Madrid       ' )
        aadd ( aItems , '29 Mlaga       ' )
        aadd ( aItems , '30 Murcia       ' )
        aadd ( aItems , '31 Navarra      ' )
        aadd ( aItems , '32 Ourense      ' )
        aadd ( aItems , '33 Asturias     ' )
        aadd ( aItems , '34 Palencia     ' )
        aadd ( aItems , '35 Las Palmas   ' )
        aadd ( aItems , '36 Pontevedra   ' )
        aadd ( aItems , '37 Salamanca    ' )
        aadd ( aItems , '38 S.C. Tenerife' )
        aadd ( aItems , '39 Santander    ' )
        aadd ( aItems , '40 Segovia      ' )
        aadd ( aItems , '41 Sevilla      ' )
        aadd ( aItems , '42 Soria        ' )
        aadd ( aItems , '43 Tarragona    ' )
        aadd ( aItems , '44 Teruel       ' )
        aadd ( aItems , '45 Toledo       ' )
        aadd ( aItems , '46 Valencia     ' )
        aadd ( aItems , '47 Valladolid   ' )
        aadd ( aItems , '48 Bilbao       ' )
        aadd ( aItems , '49 Zamora       ' )
        aadd ( aItems , '50 Zaragoza     ' )
        aadd ( aItems , '51 Ceuta        ' )
        aadd ( aItems , '52 Melilla      ' )
 
*----------------------------------------------*

        aadd ( aItemX , '01 |<-Normal 24h' )
	aadd ( aItemX , '02 |<-Extra  12h' )
        aadd ( aItemX , '03 |<-Antes  10h' )
	aadd ( aItemX , '05 |<-Mediodia  ' )
        aadd ( aItemX , '21 |<-Devolucin' )
*----------------------------------------------*

        aadd ( aItemZ , 'P. PAGADOS' )
	aadd ( aItemZ , 'P. DEBIDOS' )
 
*---------------------------------------------*
	  
  DEFINE WINDOW barcode                       ;
        AT    400,312                         ; 
        WIDTH 710 HEIGHT 582                  ;
        ICON 'Resource\goods.ico'             ;
        BACKCOLOR { 143,249,132}              ;
        TITLE "TRA-EXP (Transporter-Express)" ; 
        MAIN NOSYSMENU CURSOR ""              ;      
        ON INIT OpenTables()  
 
        ON KEY ESCAPE ACTION FinalProgram()         
  
*---------------------------------------------*


*--------------------------------------------------------------------*
   Rectangle(16,16,290,420,"12d",{ 000,000,000 } ,1,1,1 )    
*--------------------------------------------------------------------*

     DEFINE LABEL Label_01
        ROW    030
        COL    033  
        WIDTH  072 
        HEIGHT 024
        VALUE "Origen:"
        FONTNAME "Arial"
        FONTSIZE 9
        TOOLTIP "Indique Origen"   
        FONTBOLD .T.
        FONTITALIC .F.
        FONTUNDERLINE .F.
        FONTSTRIKEOUT .F.
        HELPID Nil
        VISIBLE .T.
        TRANSPARENT .F.
        ACTION Nil
        AUTOSIZE .F.
        BACKCOLOR {143,249,132}   
        FONTCOLOR Nil
     END LABEL

       nLogX  = 1

   @ 027,127 COMBOBOX Combo_01         ;        
        WIDTH 160 HEIGHT 023           ;            
        ITEMS   aItems                 ;         
        VALUE nLogX                    ;
        ON CHANGE nLogX := This.Value  ;
        FONT 'Arial' SIZE 09           ; 
        TOOLTIP 'Origen'

*-------------------------------------------------------------------*
  
     DEFINE LABEL Label_02
        ROW    060   
        COL    033  
        WIDTH  072 
        HEIGHT 024 
        VALUE "Destino"
        FONTNAME "Arial"
        FONTSIZE 9
        TOOLTIP ""
        FONTBOLD .T.
        FONTITALIC .F.
        FONTUNDERLINE .F.
        FONTSTRIKEOUT .F.
        HELPID Nil
        VISIBLE .T.
        TRANSPARENT .F.
        ACTION Nil
        AUTOSIZE .F.
        BACKCOLOR {143,249,132}  
        FONTCOLOR Nil
     END LABEL

        nLogz  = 1

   @ 057,127 COMBOBOX Combo_02         ;            
        WIDTH 160 HEIGHT 023           ;            
        ITEMS   aItems                 ;         
        VALUE nLogz                    ;
        ON CHANGE nLogz := This.Value  ;
        FONT 'Arial' SIZE 09           ; 
        TOOLTIP 'Charge'
*-------------------------------------------------------------------*

     DEFINE LABEL Label_03
        ROW    090   
        COL    033  
        WIDTH  072 
        HEIGHT 024 
        VALUE "Servicio"
        FONTNAME "Arial"
        FONTSIZE 9
        TOOLTIP ""
        FONTBOLD .T.
        FONTITALIC .F.
        FONTUNDERLINE .F.
        FONTSTRIKEOUT .F.
        HELPID Nil
        VISIBLE .T.
        TRANSPARENT .F.
        ACTION Nil
        AUTOSIZE .F.
        BACKCOLOR {143,249,132} 
        FONTCOLOR Nil
     END LABEL


     xnLogX  = 1

   @ 087,127 COMBOBOX Combo_03          ;            
        WIDTH 160 HEIGHT 023            ;            
        ITEMS  aItemX                   ;         
        VALUE xnLogX                    ;
        ON CHANGE xnLogX := This.Value  ;
        FONT 'Arial' SIZE 09            ; 
        TOOLTIP 'Origen'

*------------------------------------------------------------* 

     DEFINE LABEL Label_04x
        ROW    120 
        COL    033  
        WIDTH  072 
        HEIGHT 024 
        VALUE "Portes"
        FONTNAME "Arial"
        FONTSIZE 9
        TOOLTIP ""
        FONTBOLD .T.
        FONTITALIC .F.
        FONTUNDERLINE .F.
        FONTSTRIKEOUT .F.
        HELPID Nil
        VISIBLE .T.
        TRANSPARENT .F.
        ACTION Nil
        AUTOSIZE .F.
        BACKCOLOR {143,249,132}  
        FONTCOLOR Nil
     END LABEL

     xnLogQ  = 1

   @ 117,127 COMBOBOX Combo_04          ;            
        WIDTH 160 HEIGHT 023            ;            
        ITEMS  aItemZ                   ;         
        VALUE xnLogQ                    ;
        ON CHANGE xnLogQ := This.Value  ;
        FONT 'Arial' SIZE 09            ; 
        TOOLTIP 'Origen'

*------------------------------------------------------------------*

     DEFINE LABEL Label_05x
        ROW    155  
        COL    033  
        WIDTH  072 
        HEIGHT 024 
        VALUE "Bultos"
        FONTNAME "Arial"
        FONTSIZE 9
        TOOLTIP ""
        FONTBOLD .T.
        FONTITALIC .F.
        FONTUNDERLINE .F.
        FONTSTRIKEOUT .F.
        HELPID Nil
        VISIBLE .T.
        TRANSPARENT .F.
        ACTION Nil
        AUTOSIZE .F.
        BACKCOLOR {143,249,132}  
        FONTCOLOR Nil
     END LABEL

     DEFINE TEXTBOX Texto_05
        ROW    152
        COL    127   
        WIDTH  160   
        HEIGHT 023
        FONTNAME "Arial"
        FONTSIZE 9
        TOOLTIP ""
        ONCHANGE {|| SetConfOFF(0,Len("9999")) }
        ONGOTFOCUS Nil
        ONLOSTFOCUS Nil
        FONTBOLD .F.
        FONTITALIC .F.
        FONTUNDERLINE .F.
        FONTSTRIKEOUT .F.
        ONENTER Nil
        HELPID Nil
        TABSTOP .T.
        VISIBLE .T.
        READONLY .F.
        RIGHTALIGN .T.
        BACKCOLOR { 255,179,253 }
        FONTCOLOR NIL
        INPUTMASK "9999"
        FORMAT Nil
        NUMERIC .T. 
        VALUE 0
     END TEXTBOX 

*------------------------------------------------------------------*

     DEFINE LABEL Label_06x
        ROW    185  
        COL    033  
        WIDTH  072 
        HEIGHT 024 
        VALUE "Kilos"
        FONTNAME "Arial"
        FONTSIZE 9
        TOOLTIP ""
        FONTBOLD .T.
        FONTITALIC .F.
        FONTUNDERLINE .F.
        FONTSTRIKEOUT .F.
        HELPID Nil
        VISIBLE .T.
        TRANSPARENT .F.
        ACTION Nil
        AUTOSIZE .F.
        BACKCOLOR {143,249,132}  
        FONTCOLOR Nil
     END LABEL

     DEFINE TEXTBOX Texto_06
        ROW    182
        COL    127   
        WIDTH  160   
        HEIGHT 023
        FONTNAME "Arial"
        FONTSIZE 9
        TOOLTIP ""
        ONCHANGE {|| SetConfOFF(0,Len("99999")) }
        ONGOTFOCUS Nil
        ONLOSTFOCUS Nil
        FONTBOLD .F.
        FONTITALIC .F.
        FONTUNDERLINE .F.
        FONTSTRIKEOUT .F.
        ONENTER Nil
        HELPID Nil
        TABSTOP .T.
        VISIBLE .T.
        READONLY .F.
        RIGHTALIGN .T.
        BACKCOLOR { 255,179,253 }
        FONTCOLOR NIL
        INPUTMASK "99999"
        FORMAT Nil
        NUMERIC .T. 
        VALUE 0
    END TEXTBOX 

*--------------------------------------------------------------------*
   Box(217, 017, 289, 003 ,"14x", 000,000,000 ) 

   barcode.Label_14x.Enabled := .F.  
 *--------------------------------------------------------------------*
     DEFINE LABEL Label_07x
        ROW    235 
        COL    033  
        WIDTH  072 
        HEIGHT 024 
        VALUE "R.Nombre"
        FONTNAME "Arial"
        FONTSIZE 9
        TOOLTIP ""
        FONTBOLD .T.
        FONTITALIC .F.
        FONTUNDERLINE .F.
        FONTSTRIKEOUT .F.
        HELPID Nil
        VISIBLE .T.
        TRANSPARENT .F.
        ACTION Nil
        AUTOSIZE .F.
        BACKCOLOR {143,249,132}  
        FONTCOLOR Nil
     END LABEL

     DEFINE TEXTBOX Texto_07
        ROW    232
        COL    127   
        WIDTH  160   
        HEIGHT 023
        FONTNAME "Arial"
        FONTSIZE 9
        TOOLTIP ""
        ONCHANGE {|| SetConfOFF(30,Len("")) }
        ONGOTFOCUS Nil
        ONLOSTFOCUS Nil
        FONTBOLD .F.
        FONTITALIC .F.
        FONTUNDERLINE .F.
        FONTSTRIKEOUT .F.
        ONENTER Nil
        HELPID Nil
        TABSTOP .T.
        VISIBLE .T.
        READONLY .F.
        RIGHTALIGN .F.
        BACKCOLOR { 255,179,253 }
        FONTCOLOR Nil
        INPUTMASK Nil
        FORMAT Nil
        UPPERCASE .T.
        MAXLENGTH 30 
        VALUE ""
     END TEXTBOX 

     DEFINE LABEL Label_08x
        ROW    265   
        COL    033  
        WIDTH  072 
        HEIGHT 024 
        VALUE "R.Direccin"
        FONTNAME "Arial"
        FONTSIZE 9
        TOOLTIP ""
        FONTBOLD .T.
        FONTITALIC .F.
        FONTUNDERLINE .F.
        FONTSTRIKEOUT .F.
        HELPID Nil
        VISIBLE .T.
        TRANSPARENT .F.
        ACTION Nil
        AUTOSIZE .F.
        BACKCOLOR {143,249,132}  
        FONTCOLOR Nil
     END LABEL

     DEFINE TEXTBOX Texto_08
        ROW    262
        COL    127   
        WIDTH  160   
        HEIGHT 023
        FONTNAME "Arial"
        FONTSIZE 9
        TOOLTIP ""
        ONCHANGE {|| SetConfOFF(35,Len("")) }
        ONGOTFOCUS Nil
        ONLOSTFOCUS Nil
        FONTBOLD .F.
        FONTITALIC .F.
        FONTUNDERLINE .F.
        FONTSTRIKEOUT .F.
        ONENTER Nil
        HELPID Nil
        TABSTOP .T.
        VISIBLE .T.
        READONLY .F.
        RIGHTALIGN .F.
        BACKCOLOR { 255,179,253 }
        FONTCOLOR Nil
        INPUTMASK Nil
        FORMAT Nil
        UPPERCASE .T.
        MAXLENGTH 35 
        VALUE ""
     END TEXTBOX 

     DEFINE LABEL Label_09x
        ROW    295   
        COL    033 
        WIDTH  072 
        HEIGHT 024 
        VALUE "R.Poblacin"
        FONTNAME "Arial"
        FONTSIZE 9
        TOOLTIP ""
        FONTBOLD .T.
        FONTITALIC .F.
        FONTUNDERLINE .F.
        FONTSTRIKEOUT .F.
        HELPID Nil
        VISIBLE .T.
        TRANSPARENT .F.
        ACTION Nil
        AUTOSIZE .F.
        BACKCOLOR {143,249,132}  
        FONTCOLOR Nil
     END LABEL

     DEFINE TEXTBOX Texto_09
        ROW    292
        COL    127   
        WIDTH  160   
        HEIGHT 023
        FONTNAME "Arial"
        FONTSIZE 9
        TOOLTIP ""
        ONCHANGE {|| SetConfOFF(35,Len("")) }
        ONGOTFOCUS Nil
        ONLOSTFOCUS Nil
        FONTBOLD .F.
        FONTITALIC .F.
        FONTUNDERLINE .F.
        FONTSTRIKEOUT .F.
        ONENTER Nil
        HELPID Nil
        TABSTOP .T.
        VISIBLE .T.
        READONLY .F.
        RIGHTALIGN .F.
        BACKCOLOR { 255,179,253 }
        FONTCOLOR Nil
        INPUTMASK Nil
        FORMAT Nil
        UPPERCASE .T.
        MAXLENGTH 35 
        VALUE ""
     END TEXTBOX 

*--------------------------------------------------------------------*
   Box(328, 017, 289, 003 ,"15x", 000,000,000 ) 

   barcode.Label_15x.Enabled := .F.   
*--------------------------------------------------------------------*

     DEFINE LABEL Label_10x
        ROW    345  
        COL    033  
        WIDTH  072 
        HEIGHT 024 
        VALUE "C.Nombre"
        FONTNAME "Arial"
        FONTSIZE 9
        TOOLTIP ""
        FONTBOLD .T.
        FONTITALIC .F.
        FONTUNDERLINE .F.
        FONTSTRIKEOUT .F.
        HELPID Nil
        VISIBLE .T.
        TRANSPARENT .F.
        ACTION Nil
        AUTOSIZE .F.
        BACKCOLOR {143,249,132} 
        FONTCOLOR Nil
     END LABEL

     DEFINE TEXTBOX Texto_10
        ROW    342
        COL    127   
        WIDTH  160   
        HEIGHT 023
        FONTNAME "Arial"
        FONTSIZE 9
        TOOLTIP ""
        ONCHANGE {|| SetConfOFF(30,Len("")) }
        ONGOTFOCUS Nil
        ONLOSTFOCUS Nil
        FONTBOLD .F.
        FONTITALIC .F.
        FONTUNDERLINE .F.
        FONTSTRIKEOUT .F.
        ONENTER Nil
        HELPID Nil
        TABSTOP .T.
        VISIBLE .T.
        READONLY .F.
        RIGHTALIGN .F.
        BACKCOLOR { 255,179,253 }
        FONTCOLOR Nil
        INPUTMASK Nil
        FORMAT Nil
        UPPERCASE .T.   
        MAXLENGTH 30 
        VALUE ""
     END TEXTBOX 

     DEFINE LABEL Label_11x
        ROW    375
        COL    033 
        WIDTH  072 
        HEIGHT 024 
        VALUE "C.Direccin"
        FONTNAME "Arial"
        FONTSIZE 9
        TOOLTIP ""
        FONTBOLD .T.
        FONTITALIC .F.
        FONTUNDERLINE .F.
        FONTSTRIKEOUT .F.
        HELPID Nil
        VISIBLE .T.
        TRANSPARENT .F.
        ACTION Nil
        AUTOSIZE .F.
        BACKCOLOR {143,249,132}  
        FONTCOLOR Nil
     END LABEL

     DEFINE TEXTBOX Texto_11
        ROW    372
        COL    127   
        WIDTH  160   
        HEIGHT 023
        FONTNAME "Arial"
        FONTSIZE 9
        TOOLTIP ""
        ONCHANGE {|| SetConfOFF(35,Len("")) }
        ONGOTFOCUS Nil
        ONLOSTFOCUS Nil
        FONTBOLD .F.
        FONTITALIC .F.
        FONTUNDERLINE .F.
        FONTSTRIKEOUT .F.
        ONENTER Nil
        HELPID Nil
        TABSTOP .T.
        VISIBLE .T.
        READONLY .F.
        RIGHTALIGN .F.
        BACKCOLOR { 255,179,253 }
        FONTCOLOR Nil
        INPUTMASK Nil
        FORMAT Nil
        UPPERCASE .T.
        MAXLENGTH 35 
        VALUE ""
     END TEXTBOX 

     DEFINE LABEL Label_12x
        ROW    405   
        COL    033 
        WIDTH  072 
        HEIGHT 024 
        VALUE "C.Poblacin"
        FONTNAME "Arial"
        FONTSIZE 9
        TOOLTIP ""
        FONTBOLD .T.
        FONTITALIC .F.
        FONTUNDERLINE .F.
        FONTSTRIKEOUT .F.
        HELPID Nil
        VISIBLE .T.
        TRANSPARENT .F.
        ACTION Nil
        AUTOSIZE .F.
        BACKCOLOR {143,249,132} 
        FONTCOLOR Nil
     END LABEL

     DEFINE TEXTBOX Texto_12
        ROW    402
        COL    127   
        WIDTH  160   
        HEIGHT 023
        FONTNAME "Arial"
        FONTSIZE 9
        TOOLTIP ""
        ONCHANGE {|| SetConfOFF(35,Len("")) }
        ONGOTFOCUS Nil
        ONLOSTFOCUS Nil
        FONTBOLD .F.
        FONTITALIC .F.
        FONTUNDERLINE .F.
        FONTSTRIKEOUT .F.
        ONENTER Nil
        HELPID Nil
        TABSTOP .T.
        VISIBLE .T.
        READONLY .F.
        RIGHTALIGN .F.
        BACKCOLOR { 255,179,253 }
        FONTCOLOR Nil
        INPUTMASK Nil
        FORMAT Nil
        UPPERCASE .T.
        MAXLENGTH 35 
        VALUE ""
     END TEXTBOX 

*------------------------------------------------------------------------------------------------------------------------------------*
*------------------------------------------------------------------------------------------------------------------------------------*
*------------------------------------------------------------------------------------------------------------------------------------*

*--------------------------------------------------------------------*
    Rectangle(16,320,358,420,"13d",{ 000,000,000 } ,1,1,1 )   

     Box( 026, 330, 340, 075 ,"16x", 255,255,255 )   

     barcode.Label_16x.Enabled := .F.   
*--------------------------------------------------------------------*

     DEFINE IMAGE Fondo_1  
          ROW     040
          COL     607
          WIDTH   048
          HEIGHT  048   
          PICTURE  'Resource\goodsx.png'      
          VISIBLE .T.
          STRETCH .T.
     END IMAGE
    
     DEFINE LABEL Label_00Z         
          ROW    034
          COL    345               
          WIDTH  120   
          HEIGHT 025    
          VALUE "TRA-EXP"  
          FONTNAME ""
          FONTSIZE 20
          TOOLTIP ""
          FONTBOLD .T.
          FONTITALIC .F.
          FONTUNDERLINE .F.
          FONTSTRIKEOUT .F.
          HELPID Nil
          VISIBLE .T.
          TRANSPARENT .F.
          ACTION Nil
          AUTOSIZE .F.
          BACKCOLOR NIL  
          FONTCOLOR NIL  
       END LABEL

       DEFINE LABEL Label_00x         
          ROW    076
          COL    345                
          WIDTH  100   
          HEIGHT 025    
          VALUE DTOC(DATE())
          FONTNAME ""
          FONTSIZE 12
          TOOLTIP ""
          FONTBOLD .F.
          FONTITALIC .F.
          FONTUNDERLINE .F.
          FONTSTRIKEOUT .F.
          HELPID Nil
          VISIBLE .T.
          TRANSPARENT .F.
          ACTION Nil
          AUTOSIZE .F.
          BACKCOLOR NIL 
          FONTCOLOR NIL  
       END LABEL 

*--------------------------------------------------------------------*
    Box( 113, 330, 340, 080 ,"17x", 128,126,255 )   

    barcode.Label_17x.Enabled := .F.          
*--------------------------------------------------------------------*
 
     DEFINE LABEL Label_01x         
          ROW    122  
          COL    345               
          WIDTH  300   
          HEIGHT 020    
          VALUE NIL
          FONTNAME ""
          FONTSIZE 10
          TOOLTIP ""
          FONTBOLD .F.
          FONTITALIC .F.
          FONTUNDERLINE .F.
          FONTSTRIKEOUT .F.
          HELPID Nil
          VISIBLE .T.
          TRANSPARENT .F.
          ACTION Nil
          AUTOSIZE .F.
          BACKCOLOR { 128,126,255 }       
          FONTCOLOR { 000,000,000 }   
     END LABEL 

     DEFINE LABEL Label_02x       
          ROW    138   
          COL    343        
          WIDTH  300   
          HEIGHT 043  
          VALUE NIL
          FONTNAME ""
          FONTSIZE 28
          TOOLTIP ""
          FONTBOLD .F.
          FONTITALIC .F.
          FONTUNDERLINE .F.
          FONTSTRIKEOUT .F.
          HELPID Nil
          VISIBLE .T.
          TRANSPARENT .F.
          ACTION Nil
          AUTOSIZE .F.
          BACKCOLOR { 128,126,255 }        
          FONTCOLOR { 000,000,000 }   
       END LABEL 

*-------------------------------------------------------------------*
    Box( 204, 330, 340, 130 ,"18x", 128,126,255 ) 

    barcode.Label_18x.Enabled := .F.           
*-------------------------------------------------------------------*

     DEFINE LABEL Label_3          // <---------  Representacin Dibujo CodeBar
          ROW    217 
          COL    410         
          WIDTH  180   
          HEIGHT 085   
          VALUE NIL
          FONTNAME "PF Interleaved 2 of 5"     //"CODE EAN13"<--- Alternativo Bueno
          FONTSIZE 50  
          TOOLTIP ""
          FONTBOLD .F.
          FONTITALIC .F.
          FONTUNDERLINE .F.
          FONTSTRIKEOUT .F.
          HELPID Nil
          VISIBLE .T.  
          TRANSPARENT .F.
          ACTION Nil
          AUTOSIZE .F.
          BACKCOLOR { 128,126,255 }    
          FONTCOLOR { 000,000,000 }   
     END LABEL 

     DEFINE LABEL Label_04       // <---------  Representacin Nmero CodeBar
        ROW    300  
        COL    425   
        WIDTH  200  
        HEIGHT 020 
        VALUE ""
        FONTNAME "Arial"
        FONTSIZE 13
        TOOLTIP ""   
        FONTBOLD .T.
        FONTITALIC .F.
        FONTUNDERLINE .F.
        FONTSTRIKEOUT .F.
        HELPID Nil
        VISIBLE .T.
        TRANSPARENT .F.
        ACTION Nil
        AUTOSIZE .F.
        BACKCOLOR { 128,126,255 }  
        FONTCOLOR { 000,000,000 }    
     END LABEL

*--------------------------------------------------------------------*
     Box( 345, 330, 340, 078 ,"19x", 255,255,255 )   

     barcode.Label_19x.Enabled := .F.   
*--------------------------------------------------------------------*

     DEFINE LABEL Label_06         
          ROW    355    
          COL    345               
          WIDTH  250   
          HEIGHT 023   
          VALUE ""  
          FONTNAME "ARIAL"
          FONTSIZE 10
          TOOLTIP ""
          FONTBOLD .T.
          FONTITALIC .F.
          FONTUNDERLINE .F.
          FONTSTRIKEOUT .F.
          HELPID Nil
          VISIBLE .T.
          TRANSPARENT .F.
          ACTION Nil
          AUTOSIZE .F.
          BACKCOLOR NIL  
          FONTCOLOR NIL  
     END LABEL

     DEFINE LABEL Label_07        
          ROW    375  
          COL    345               
          WIDTH  300  
          HEIGHT 023  
          VALUE ""  
          FONTNAME "ARIAL"
          FONTSIZE 10
          TOOLTIP ""
          FONTBOLD .T.
          FONTITALIC .F.
          FONTUNDERLINE .F.
          FONTSTRIKEOUT .F.
          HELPID Nil
          VISIBLE .T.
          TRANSPARENT .F.
          ACTION Nil
          AUTOSIZE .F.
          BACKCOLOR NIL  
          FONTCOLOR NIL  
     END LABEL

     DEFINE LABEL Label_08        
          ROW    396  
          COL    345                
          WIDTH  200   
          HEIGHT 025  
          VALUE ""  
          FONTNAME "ARIAL"
          FONTSIZE 9
          TOOLTIP ""
          FONTBOLD .T.
          FONTITALIC .F.
          FONTUNDERLINE .F.
          FONTSTRIKEOUT .F.
          HELPID Nil
          VISIBLE .T.
          TRANSPARENT .F.
          ACTION Nil
          AUTOSIZE .F.
          BACKCOLOR NIL  
          FONTCOLOR NIL  
     END LABEL

     DEFINE LABEL Label_09        
          ROW    396   
          COL    490               
          WIDTH  150  
          HEIGHT 025  
          VALUE ""  
          FONTNAME "ARIAL"
          FONTSIZE 9
          TOOLTIP ""
          FONTBOLD .T.
          FONTITALIC .F.
          FONTUNDERLINE .F.
          FONTSTRIKEOUT .F.
          HELPID Nil
          VISIBLE .T.
          TRANSPARENT .F.
          ACTION Nil
          AUTOSIZE .F.
          BACKCOLOR NIL  
          FONTCOLOR NIL  
     END LABEL

*--------------------------------------------------------------------------------------------------------*
*-------------------------------------  Estructura HMG_Zebra No Borrar dejar en  HIDE  ------------------*
*--------------------------------------------------------------------------------------------------------*

   @ 10,110 combobox type width 100  items aTypeItems  ON CHANGE barcode.code.value := aValues [ barcode.Type.value ]    
      
      barcode.type.hide

*--------------------------------------------------------------------------------------------------------*
   @ 40,110 textbox code width 120
  
    barcode.code.hide
*--------------------------------------------------------------------------------------------------------*   
  
   define spinner linewidth
          row 70
          col 110
          width 80
          value 2
          rightalign .t.
          rangemin 1
          rangemax 200
      end spinner
    
   barcode.linewidth.hide


*--------------------------------------------------------------------------------------------------------*

   define spinner lineheight
          row 100
          col 110
          width 80
          value 110
          rightalign .t.
          increment 10
          rangemin 10
          rangemax 2000
      end spinner

  barcode.lineheight.hide

*--------------------------------------------------------------------------------------------------------*

  @ 130,010 CHECKBOX showdigits CAPTION "" WIDTH  120  VALUE .T. 

    barcode.showdigits.hide

*--------------------------------------------------------------------------------------------------------*

  @ 130, 150 CHECKBOX checksum CAPTION "" WIDTH  120 VALUE .T. 

    barcode.checksum.hide

*--------------------------------------------------------------------------------------------------------*

   @ 130, 150 CHECKBOX  wide2_5 CAPTION "" WIDTH  120 on change iif( this.value, barcode.wide3.value := .f., )

    barcode. wide2_5.hide

*--------------------------------------------------------------------------------------------------------*

   @ 130, 150 CHECKBOX  wide3 CAPTION "" WIDTH  120  on change iif( this.value, barcode.wide2_5.value := .f., )

   barcode.wide3.hide

*--------------------------------------------------------------------------------------------------------*
*-------------------------------------------------    End Hide    ---------------------------------------*
*--------------------------------------------------------------------------------------------------------*    
      
    DEFINE BUTTON Button_01
        ROW    470   
        COL    017
        WIDTH  123
        HEIGHT 042   
        CAPTION "A&ccept"
        ACTION BuscaNom()         
        FONTNAME "Arial"
        FONTSIZE 9
        TOOLTIP "Acept"
        FONTBOLD .T.
        FONTITALIC .T.
        FONTUNDERLINE .F.
        FONTSTRIKEOUT .F.
        ONGOTFOCUS Nil
        ONLOSTFOCUS Nil
        HELPID Nil
        FLAT .F.
        TABSTOP .T.
        VISIBLE .T.
        TRANSPARENT .F.
        MULTILINE .F.
        PICTURE "resource\Acep.bmp"
        PICTALIGNMENT LEFT
    END BUTTON

    DEFINE BUTTON Button_02      
        ROW    470   
        COL    152
        WIDTH  123
        HEIGHT 042  
        CAPTION "P&rint"
        ACTION hmg_printex()                 
        FONTNAME "Arial"
        FONTSIZE 9
        TOOLTIP "Print"
        FONTBOLD .T.
        FONTITALIC .T.
        FONTUNDERLINE .F.
        FONTSTRIKEOUT .F.
        ONGOTFOCUS Nil
        ONLOSTFOCUS Nil
        HELPID Nil
        FLAT .F.
        TABSTOP .T.
        VISIBLE .T.
        TRANSPARENT .F.
        MULTILINE .F.
        PICTURE "resource\Print.bmp"
        PICTALIGNMENT LEFT
     END BUTTON

    DEFINE BUTTON Button_03     
        ROW    470   
        COL    285
        WIDTH  123
        HEIGHT 042  
        CAPTION "Delete Base"
        ACTION  Delete_Base()
        FONTNAME "Arial"
        FONTSIZE 9
        TOOLTIP "Delete"
        FONTBOLD .T.
        FONTITALIC .T.
        FONTUNDERLINE .F.
        FONTSTRIKEOUT .F.
        ONGOTFOCUS Nil
        ONLOSTFOCUS Nil
        HELPID Nil
        FLAT .F.
        TABSTOP .T.
        VISIBLE .T.
        TRANSPARENT .F.
        MULTILINE .F.
        PICTURE "resource\Basex.bmp"
        PICTALIGNMENT LEFT
     END BUTTON
 
     DEFINE BUTTON Button_04    
        ROW    470   
        COL    421
        WIDTH  123
        HEIGHT 042  
        CAPTION "Delete Labels"
        ACTION  Delete_Label()
        FONTNAME "Arial"
        FONTSIZE 9
        TOOLTIP "Delete"
        FONTBOLD .T.
        FONTITALIC .T.
        FONTUNDERLINE .F.
        FONTSTRIKEOUT .F.
        ONGOTFOCUS Nil
        ONLOSTFOCUS Nil
        HELPID Nil
        FLAT .F.
        TABSTOP .T.
        VISIBLE .T.
        TRANSPARENT .F.
        MULTILINE .F.
        PICTURE "resource\Label.bmp"  
        PICTALIGNMENT LEFT
     END BUTTON


      DEFINE BUTTON Button_05     
        ROW    470   
        COL    558
        WIDTH  123
        HEIGHT 042   
        CAPTION "E&xit"
        ACTION FinalProgram()         
        FONTNAME "Arial"
        FONTSIZE 9
        TOOLTIP "Exit"
        FONTBOLD .T.
        FONTITALIC .T.
        FONTUNDERLINE .F.
        FONTSTRIKEOUT .F.
        ONGOTFOCUS Nil
        ONLOSTFOCUS Nil
        HELPID Nil
        FLAT .F.
        TABSTOP .T.
        VISIBLE .T.
        TRANSPARENT .F.
        MULTILINE .F.
        PICTURE "resource\Cancel.bmp"
        PICTALIGNMENT LEFT
     END BUTTON

   END WINDOW

   barcode.type.value := 1
   barcode.center
   barcode.activate  
    

 RETURN NIL
 
*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*

*------------------------------------------*
 Function FinalProgram()
*------------------------------------------*

 IF MsgYesNo("Do you want to finish the program ?","Atention !!!") = .T.
       CLOSE DATABASES
       barcode.Release
    Return .T.
 EndIf

 return nil

*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*


*------------------------------------------*
 Function OpenTables()
*------------------------------------------*
 
   CLOSE DATABASES
   SELECT 1
   USE TRANS_PORT new
   index ON COD_BAR TO TRANS_PORT
   CLOSE DATABASES

 return nil

*---------------------------------------------*
 FUNCTION SetConfOFF( nMaxLength, nInputMask )
*---------------------------------------------*

 Local cFrmName   := ThisWindow.Name
 Local cCmpName   := This.FocusedControl

 If nInputMask > 0
    nMaxLength := nInputMask
 Endif

 If !Empty(cCmpName)
    If nMaxLength == GetProperty(cFrmName,cCmpName,"CaretPos")
       InsertTab()
    Endif
 Endif
Return Nil

*----------------------------------*
 Function Delete_Base()
*----------------------------------*

 LOCAL Erater  := .F.
 CLOSE DATABASES
 SELECT 1
 USE TRANS_PORT

 IF MsgYesNo('Desea Borrar Base Datos ?','Atencin')
    Erater := .T.
    SELECT 1
    ZAP
    CLOSE DATABASES
    FileDelete( "Code_Bar\*.jpg" )
    RETURN
  ELSE
   Erater := .F.
   CLOSE DATABASES
   RETURN
 ENDIF

 RETURN NIL


*----------------------------------*
 Function Delete_Label()
*----------------------------------*
  LOCAL Label_Erater  := .F.
 
 IF MsgYesNo('Desea Borrar Labels ?','Atencin')
    Label_Erater := .T.
    FileDelete( "Labels\*.pdf" )
    RETURN
  ELSE
   Label_Erater := .F.
   RETURN
 ENDIF

 RETURN NIL

*----------------------------------*
 Function BuscaNom()
*----------------------------------*

  PRIVATE BusNom , BusNomX ,  primpalix , BusCla, BusCar
  PRIVATE mirax  , codig
  PRIVATE miraz  , codiz
  PRIVATE xmiraz , xcodiz
  PRIVATE xmiraQ , xcodiQ
 
*------------------------------------------- Combo_01 -------------------------------------------------*
                                    
 IF nLogX = 1
    mirax := '01 lava'   
    codig := '01'
 ENDIF   

 IF nLogX = 2
    mirax := '02 Albacete' 
    codig := '02'
 ENDIF   
                                    
 IF nLogX = 3
    mirax := '03 Alicante' 
    codig := '03'
 ENDIF   

 IF nLogX = 4
    mirax := '04 Almera'
    codig := '04'
 ENDIF   
                                    
 IF nLogX = 5
    mirax := '05 vila'
    codig := '05'
 ENDIF   

 IF nLogX = 6
    mirax := '06 Badajoz'
    codig := '06'
 ENDIF   
                                    
 IF nLogX = 7
    mirax := '07 P.Mallorca'
    codig := '07'
 ENDIF   

 IF nLogX = 8
    mirax := '08 Barcelona' 
    codig := '08'
 ENDIF   
                                    
 IF nLogX = 9
    mirax := '09 Burgos'
    codig := '09'
 ENDIF   

 IF nLogX = 10
    mirax := '10 Cceres' 
    codig := '10'
 ENDIF   

 IF nLogX = 11
    mirax := '11 Cdiz' 
    codig := '11'
 ENDIF   

 IF nLogX = 12
    mirax := '12 Castelln' 
    codig := '12'
 ENDIF   
                                    
 IF nLogX = 13
    mirax := '13 Ciudad Real'
    codig := '13'
 ENDIF   

 IF nLogX = 14
    mirax := '14 Crdoba'
    codig := '14'
 ENDIF   
                                    
 IF nLogX = 15
    mirax := '15 Corua' 
    codig := '15'
 ENDIF   

 IF nLogX = 16
    mirax := '16 Cuenca' 
    codig := '16'
 ENDIF   
                                    
 IF nLogX = 17
    mirax := '17 Girona'
    codig := '17'
 ENDIF   

 IF nLogX = 18
    mirax := '18 Granada'
    codig := '18'
 ENDIF   
                                    
 IF nLogX = 19
    mirax := '19 Guadalajara'
    codig := '19'
 ENDIF   

 IF nLogX = 20
    mirax := '20 San Sebastian' 
    codig := '20'
 ENDIF   

 IF nLogX = 21
    mirax := '21 Huelva' 
    codig := '21'
 ENDIF   

 IF nLogX = 22
    mirax := '22 Huesca' 
    codig := '22'
 ENDIF   
                                    
 IF nLogX = 23
    mirax := '23 Jan'
    codig := '23'
 ENDIF   

 IF nLogX = 24
    mirax := '24 Len'
    codig := '24'
 ENDIF   
                                    
 IF nLogX = 25
    mirax := '25 Lleida' 
    codig := '25'
 ENDIF   

 IF nLogX = 26
    mirax := '26 Logroo' 
    codig := '26'
 ENDIF   
                                    
 IF nLogX = 27
    mirax := '27 Lugo' 
    codig := '27'
 ENDIF   

 IF nLogX = 28
    mirax := '28 Madrid'
    codig := '28'
 ENDIF   
                                    
 IF nLogX = 29
    mirax := '29 Mlaga' 
    codig := '29'
 ENDIF   

 IF nLogX = 30
    mirax := '30 Murcia'
    codig := '30'
 ENDIF   

IF nLogX = 31
    mirax := '31 Navarra' 
    codig := '31'
 ENDIF   

 IF nLogX = 32
    mirax :=  '32 Ourense'
    codig := '32'
 ENDIF   
                                    
 IF nLogX = 33
    mirax := '33 Asturias'
    codig := '33'
 ENDIF   

 IF nLogX = 34
    mirax := '34 Palencia'
    codig := '34'
 ENDIF   
                                    
 IF nLogX = 35
    mirax := '35 Las Palmas' 
    codig := '35'
 ENDIF   

 IF nLogX = 36
    mirax := '36 Pontevedra'
    codig := '36'
 ENDIF   
                                    
 IF nLogX = 37
    mirax := '37 Salamanca'
    codig := '37'
 ENDIF   

 IF nLogX = 38
    mirax := '38 S.C. Tenerife'
    codig := '38'
 ENDIF   
                                    
 IF nLogX = 39
    mirax := '39 Santander'
    codig := '39'
 ENDIF   

 IF nLogX = 40
    mirax := '40 Segovia'
    codig := '40'
 ENDIF  
 
IF nLogX = 41
    mirax := '41 Sevilla'
    codig := '41'
 ENDIF 
  
IF nLogX = 42
    mirax :=  '42 Soria'
    codig := '42'
 ENDIF   

IF nLogX = 43
    mirax := '43 Tarragona' 
    codig := '43'
 ENDIF   

IF nLogX = 44
    mirax := '44 Teruel' 
    codig := '44'
 ENDIF 
  
IF nLogX = 45
    mirax := '45 Toledo'
    codig := '45'
 ENDIF  
 
IF nLogX = 46
    mirax := '46 Valencia' 
    codig := '46'
 ENDIF   

IF nLogX = 47
    mirax := '47 Valladolid'
    codig := '47'
 ENDIF 
  
IF nLogX = 48
    mirax := '48 Bilbao'
    codig := '48'
 ENDIF   
IF nLogX = 49
    mirax := '49 Zamora'
    codig := '49'
 ENDIF  
 
IF nLogX = 50
    mirax := '50 Zaragoza' 
    codig := '50'
 ENDIF   

IF nLogX = 51
    mirax := '51 Ceuta'
    codig := '51'
 ENDIF   

IF nLogX = 52
    mirax := '52 Melilla'
    codig := '52'
 ENDIF   
 
*------------------------------------------- Combo_02 -------------------------------------------------
                                   
 IF nLogz = 1
    miraz := '01 lava'   
    codiz := '01'
 ENDIF   

 IF nLogz = 2
    miraz := '02 Albacete' 
    codiz := '02'
 ENDIF   
                                    
 IF nLogz = 3
    miraz := '03 Alicante' 
    codiz := '03'
 ENDIF   

 IF nLogz = 4
    miraz := '04 Almera'
    codiz := '04'
 ENDIF   
                                    
 IF nLogz = 5
    miraz := '05 vila'
    codiz := '05'
 ENDIF   

 IF nLogz = 6
    miraz := '06 Badajoz'
    codiz := '06'
 ENDIF   
                                    
 IF nLogz = 7
    miraz := '07 P.Mallorca'
    codiz := '07'
 ENDIF   

 IF nLogz = 8
    miraz := '08 Barcelona' 
    codiz := '08'
 ENDIF   
                                    
 IF nLogz = 9
    miraz := '09 Burgos'
    codiz := '09'
 ENDIF   

 IF nLogz = 10
    miraz := '10 Cceres' 
    codiz := '10'
 ENDIF   

 IF nLogz = 11
    miraz := '11 Cdiz' 
    codiz := '11'
 ENDIF   

 IF nLogz = 12
    miraz := '12 Castelln' 
    codiz := '12'
 ENDIF   
                                    
 IF nLogz = 13
    miraz := '13 Ciudad Real'
    codiz := '13'
 ENDIF   

 IF nLogz = 14
    miraz := '14 Crdoba'
    codiz := '14'
 ENDIF   
                                    
 IF nLogz = 15
    miraz := '15 Corua' 
    codiz := '15'
 ENDIF   

 IF nLogz = 16
    miraz := '16 Cuenca' 
    codiz := '16'
 ENDIF   
                                    
 IF nLogz = 17
    miraz := '17 Girona'
    codiz := '17'
 ENDIF   

 IF nLogz = 18
    miraz := '18 Granada'
    codiz := '18'
 ENDIF   
                                    
 IF nLogz = 19
    miraz := '19 Guadalajara'
    codiz := '19'
 ENDIF   

 IF nLogz = 20
    miraz := '20 San Sebastian' 
    codiz := '20'
 ENDIF   

 IF nLogz = 21
    miraz := '21 Huelva' 
    codiz := '21'
 ENDIF   

 IF nLogz = 22
    miraz := '22 Huesca' 
    codiz := '22'
 ENDIF   
                                    
 IF nLogz = 23
    miraz := '23 Jan'
    codiz := '23'
 ENDIF   

 IF nLogz = 24
    miraz := '24 Len'
    codiz := '24'
 ENDIF   
                                    
 IF nLogz = 25
    miraz := '25 Lleida' 
    codiz := '25'
 ENDIF   

 IF nLogz = 26
    miraz := '26 Logroo' 
    codiz := '26'
 ENDIF   
                                    
 IF nLogz = 27
    miraz := '27 Lugo' 
    codiz := '27'
 ENDIF   

 IF nLogz = 28
    miraz := '28 Madrid'
    codiz := '28'
 ENDIF   
                                    
 IF nLogz = 29
    miraz := '29 Mlaga' 
    codiz := '29'
 ENDIF   

 IF nLogz = 30
    miraz := '30 Murcia'
    codiz := '30'
 ENDIF   

IF nLogz = 31
    miraz := '31 Navarra' 
    codiz := '31'
 ENDIF   

 IF nLogz = 32
    miraz :=  '32 Ourense'
    codiz := '32'
 ENDIF   
                                    
 IF nLogX = 33
    mirax := '33 Asturias'
    codig := '33'
 ENDIF   

 IF nLogz = 34
    miraz := '34 Palencia'
    codiz := '34'
 ENDIF   
                                    
 IF nLogz = 35
    miraz := '35 Las Palmas' 
    codiz := '35'
 ENDIF   

 IF nLogz = 36
    miraz := '36 Pontevedra'
    codiz := '36'
 ENDIF   
                                    
 IF nLogz = 37
    miraz := '37 Salamanca'
    codiz := '37'
 ENDIF   

 IF nLogz = 38
    miraz := '38 S.C. Tenerife'
    codiz := '38'
 ENDIF   
                                    
 IF nLogz = 39
    miraz := '39 Santander'
    codiz := '39'
 ENDIF   

 IF nLogz = 40
    miraz := '40 Segovia'
    codiz := '40'
 ENDIF  
 
IF nLogz = 41
    miraz := '41 Sevilla'
    codiz := '41'
 ENDIF 
  
IF nLogz = 42
    miraz :=  '42 Soria'
    codiz := '42'
 ENDIF   

IF nLogz = 43
    miraz := '43 Tarragona' 
    codiz := '43'
 ENDIF   

IF nLogz = 44
    miraz := '44 Teruel' 
    codiz := '44'
 ENDIF 
  
IF nLogz = 45
    miraz := '45 Toledo'
    codiz := '45'
 ENDIF  
 
IF nLogz = 46
    miraz := '46 Valencia' 
    codiz := '46'
 ENDIF   

IF nLogz = 47
    miraz := '47 Valladolid'
    codiz := '47'
 ENDIF 
  
IF nLogz = 48
    miraz := '48 Bilbao'
    codiz := '48'
 ENDIF 
  
IF nLogz = 49
    miraz := '49 Zamora'
    codiz := '49'
 ENDIF  
 
IF nLogz = 50
    miraz := '50 Zaragoza' 
    codiz := '50'
 ENDIF   

IF nLogz = 51
    miraz := '51 Ceuta'
    codiz := '51'
 ENDIF   

IF nLogz = 52
    miraz := '52 Melilla'
    codiz := '52'
 ENDIF   

*------------------------------------------- Combo_03 -------------------------------------------------*                             
                                      
 IF xnLogX  = 1
    xmiraz := '01 |<-Normal 24h'
    xcodiz := '01'
 ENDIF   

 IF xnLogX  = 2 
    xmiraz :=  '02 |<-Extra  12h' 
    xcodiz := '02'
 ENDIF   

 IF xnLogX = 3 
    xmiraz := '03 |<-Antes  10h' 
    xcodiz := '03'
 ENDIF 
  
 IF xnLogX  = 4
    xmiraz := '05 |<-Mediodia  ' 
    xcodiz := '05'
 ENDIF   

 IF xnLogX  = 5 
    xmiraz := '21 |<-Devolucin'
    xcodiz := '21'
 ENDIF

*------------------------------------------- Combo_04 -------------------------------------------------*                                        

 IF xnLogQ  = 1
    xmiraQ :=  'P. PAGADOS' 
 ENDIF   
 
 IF xnLogQ  = 2
    xmiraQ :=  'P. DEBIDOS'
 ENDIF  

*--------------------------------------------------------------------------------------------------------*
*--------------------------------------------------------------------------------------------------------*

   BusNomX := ALLTRIM(xcodiz)

   numix :=  barcode.Texto_05.value 

   IF  numix = 0
       MsgStop( 'Falta n Bultos','Error Bultos')
       RETURN
   ENDIF

   bultox :=  barcode.Texto_06.value 

   IF  bultox = 0
       MsgStop( 'Falta n Kilos','Error Kilos')
       RETURN
   ENDIF

*-----------------------------------------------------------------------*  

  PRIVATE HORAq  := RIGHT(TIME(), 4)       && <--------- Separa por Atras    
  PRIVATE HORAx  := STRTRAN(HORAq, ':')    && <--------- eliminas los dos puntos(:) 
  PRIVATE Nexty  := VAL(HORAx) 
* PRIVATE dirax  := SUBSTR ( HORAx, 4)     && <--------- Separa por delante 
  PRIVATE dirax  := RIGHT( HORAx, 2) 

  IF Nexty  <= 030 
     Nexty  := VAL(HORAx) + 7234  
  ELSE   
     Nexty  := VAL(HORAx) + 5291           // IF LEN( Primpaliz ) < 13   Numero de digitos
  ENDIF

  primpalix := ALLTRIM(codig)+ALLTRIM(codiz)+ BusNomX+ ALLTRIM(STR(Nexty)) +ALLTRIM(HORAx)        
  
  Primpaliz := ALLTRIM(codig)+SPACE(1)+ALLTRIM(codiz)+SPACE(3)+BusNomX+SPACE(3)+ALLTRIM(STR(Nexty))+ALLTRIM(HORAx)        

*-------------------------------------------------------------------------------------------------------------------*
  
   CLOSE DATABASES
 
   SELECT 1
   USE TRANS_PORT index TRANS_PORT

   FOR i = 1  TO numix
     APPEND BLANK  
     REPLACE  COD_BAR  WITH  primpalix
     REPLACE  ORIGEN   WITH  mirax 
     REPLACE  DESTINO  WITH  miraz 
   IF xnLogX  = 5
     REPLACE  PORTES   WITH "P.DEBIDOS"
   ELSE
     REPLACE  PORTES   WITH  xmiraQ
   ENDIF
     REPLACE  BULTOS   WITH  numix      
     REPLACE  KILOS    WITH  bultox     
     REPLACE  IMPRES   WITH  "NO"
     REPLACE  FECHA    WITH  DATE()
     REPLACE  HORA     WITH  LEFT(TIME(),5)
     REPLACE  BAR_JPG  WITH  'Code_Bar\'+primpalix+'.jpg'
     REPLACE  SERVICIO WITH  xcodiz 
     REPLACE  REM_NAME WITH  ALLTRIM(barcode.Texto_07.value)  
     REPLACE  REM_DRES WITH  ALLTRIM(barcode.Texto_08.value) 
     REPLACE  REM_POB  WITH  ALLTRIM(barcode.Texto_09.value) 
     REPLACE  CON_NAME WITH  ALLTRIM(barcode.Texto_10.value) 
     REPLACE  CON_DRES WITH  ALLTRIM(barcode.Texto_11.value) 
     REPLACE  CON_POB  WITH  ALLTRIM(barcode.Texto_12.value)  
   NEXT i
  
 CLOSE DATABASES

     barcode.Combo_01.value := 1
     barcode.Combo_02.value := 1
     barcode.Combo_03.value := 1
     barcode.Combo_04.value := 1
     barcode.Texto_05.value := 0
     barcode.Texto_06.value := 0

     barcode.Texto_07.value := ""
     barcode.Texto_08.value := ""
     barcode.Texto_09.value := ""
     barcode.Texto_10.value := ""
     barcode.Texto_11.value := ""
     barcode.Texto_12.value := ""

     barcode.Label_01x.value := ""
     barcode.Label_02x.value := "" 

     barcode.Label_01x.value :=  "de " + ALLTRIM( SUBSTR( mirax ,3) ) + " a"    
     barcode.Label_02x.value :=  ALLTRIM( SUBSTR( miraz,3) )

     barcode.Label_04.value :=   Primpaliz

     barcode.Label_06.value := 'Portes:'+ SPACE(6) + ALLTRIM(xmiraQ)    
     barcode.Label_07.value := 'Servicio:' +SPACE(3) + ALLTRIM( xmiraz )  //+SPACE(3)+ ALLTRIM(xcodiz)
     barcode.Label_08.value := 'Bultos:'+SPACE(9)+ALLTRIM(STR(numix))    
 
   IF bultox = 1 
      barcode.Label_09.value := 'Kilo:' +SPACE(5)+ALLTRIM(STR(bultox)) 
   ELSE
      barcode.Label_09.value := 'Kilos:' +SPACE(4)+ALLTRIM(STR(bultox)) 
   ENDIF

     Cnumero := primpalix 

     BarEAN13( Cnumero )

     CLOSE DATABASES

     createbarcode()
     
RETURN NIL
 
*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*

*-----------------------------
Procedure BarEAN13(Cnumero)
*-----------------------------
 
Declare Tab1CodBar[10]
Tab1CodBar[ 1] := "-AAAAAA"
Tab1CodBar[ 2] := "-AABABB"
Tab1CodBar[ 3] := "-AABBAB"
Tab1CodBar[ 4] := "-AABBBA"
Tab1CodBar[ 5] := "-ABAABB"
Tab1CodBar[ 6] := "-ABBAAB"
Tab1CodBar[ 7] := "-ABBBAA"
Tab1CodBar[ 8] := "-ABABAB"
Tab1CodBar[ 9] := "-ABABBA"
Tab1CodBar[10] := "-ABBABA"
LitCD          := ""


** Primer dgito
LitCD := left(Cnumero,1)

** Dgitos del 2 al 7
For HH = 2 to 7
   LetraTabla := substr(Tab1CodBar[val(left(Cnumero,1))+1],HH,1)
   if LetraTabla = "A"
      LitCD += chr( 65 + val(substr(Cnumero,HH,1)) )
   else // "B"
      LitCD += chr( 75 + val(substr(Cnumero,HH,1)) )
   endif
Next 

LitCD += "*"

** Dgitos del 8 al 13
For HH = 8 to 13
   LitCD += chr( 97 + val(substr(Cnumero,HH,1)) )
Next

LitCD += "+"

  barcode.Label_3.Value := " "     
  barcode.Label_3.Value := LitCD
  barcode.Label_3.refresh 

Retur


*--------------------------------------------------------------------------------------------------------------------------------*
*--------------------------------------------------------------------------------------------------------------------------------*


*-------------------------*
 Function CreateBarCode()
*-------------------------*

   local hBitMap

   barcode.code.value := ALLTRIM(primpalix)
  

   hBitMap := HMG_CreateBarCode( barcode.code.value,;    
                   barcode.type.item( barcode.type.value ),;
                   barcode.linewidth.value,;
                   barcode.lineheight.value,;
                   barcode.showdigits.value,;
                   '',;
                   aBarColor,;
                   aBackColor,;
                   barcode.checksum.value,;  
                   barcode.wide2_5.value,;  
                   barcode.wide3.value )       
 
   CreateBarCodepng()

         
RETURN NIL   

*---------------------------*
 Function CreateBarCodepng()
*---------------------------*

   local cImageFileName := ''

   barcode.code.value := ALLTRIM(primpalix)

   cImageFileName := 'Code_Bar\'+ primpalix+'.jpg'                
    
   HMG_CreateBarCode( barcode.code.value,;     
                   barcode.type.item( barcode.type.value ),;
                   barcode.linewidth.value,;
                   barcode.lineheight.value,;
                   barcode.showdigits.value,;
                   cImageFileName,;
                   aBarColor,;
                   aBackColor,;
                   barcode.checksum.value,; 
                   barcode.wide2_5.value,; 
                   barcode.wide3.value )       
      
RETURN NIL 

*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*




       
   









































